Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.modeshape.graph.connector
Class RepositorySourceCapabilities

    java.lang.Object
      org.modeshape.graph.connector.RepositorySourceCapabilities

    @Immutable
    public class RepositorySourceCapabilities

extends Object

The capabilities of a `RepositorySource`. This class can be used as is, or subclassed by a connector to define more complex behavior.

See Also:
  `RepositorySource.getCapabilities()`

Field Summary
`static boolean` | `DEFAULT_SUPPORT_AUTOMATIC_GARBAGE_COLLECTION` The default support for automatic garbage collection is true .
`static boolean` | `DEFAULT_SUPPORT_CREATING_WORKSPACES` The default support for creating workspaces is false .
`static boolean` | `DEFAULT_SUPPORT_EVENTS` The default support for updates is false .
`static boolean` | `DEFAULT_SUPPORT_LOCKS` The default support for creating locks is false .
`static boolean` | `DEFAULT_SUPPORT_QUERIES` The default support for querying workspaces is false .
`static boolean` | `DEFAULT_SUPPORT_REFERENCES` The default support for references is true .
`static boolean` | `DEFAULT_SUPPORT_SAME_NAME_SIBLINGS` The default support for same-name-siblings is true .
`static boolean` | `DEFAULT_SUPPORT_SEARCHES` The default support for searching workspaces is false .
`static boolean` | `DEFAULT_SUPPORT_UPDATES` The default support for updates is false .

Constructor Summary
`RepositorySourceCapabilities()` Create a capabilities object using the defaults, .
`RepositorySourceCapabilities(boolean supportsSameNameSiblings, boolean supportsUpdates)`
`RepositorySourceCapabilities(boolean supportsSameNameSiblings, boolean supportsUpdates, boolean supportsEvents, boolean supportsCreatingWorkspaces, boolean supportsReferences)`
`RepositorySourceCapabilities(boolean supportsSameNameSiblings, boolean supportsUpdates, boolean supportsEvents, boolean supportsCreatingWorkspaces, boolean supportsReferences, boolean supportsLocks, boolean supportsQueries, boolean supportsSearches, boolean supportsAutomaticGarbageCollection)`
`RepositorySourceCapabilities(RepositorySourceCapabilities capabilities)`

Method Summary
`boolean` | `supportsAutomaticGarbageCollection()` Return whether the source supports automatic garbage collection.
`boolean` | `supportsCreatingWorkspaces()` Return whether the source supports creating workspaces through the connector.
`boolean` | `supportsEvents()` Return whether the source supports publishing change events.
`boolean` | `supportsLocks()` Return whether the source supports creating locks.
`boolean` | `supportsQueries()` Return whether the source supports queries.
`boolean` | `supportsReferences()` Return whether the source supports references by identifiers.
`boolean` | `supportsSameNameSiblings()` Return whether the source supports same name siblings.
`boolean` | `supportsSearches()` Return whether the source supports full-text searches.
`boolean` | `supportsUpdates()` Return whether the source supports updates.
`RepositorySourceCapabilities` | `withAutomaticGarbageCollection(boolean autoGarbageCollection)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsAutomaticGarbageCollection()`.
`RepositorySourceCapabilities` | `withCreatingWorkspaces(boolean creatingWorkspaces)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsCreatingWorkspaces()` .
`RepositorySourceCapabilities` | `withEvents(boolean events)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsEvents()`.
`RepositorySourceCapabilities` | `withLocks(boolean locks)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsLocks()`.
`RepositorySourceCapabilities` | `withQueries(boolean queries)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsQueries()`.
`RepositorySourceCapabilities` | `withReferences(boolean references)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsReferences()`.
`RepositorySourceCapabilities` | `withSameNameSiblings(boolean sameNameSiblings)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsSameNameSiblings()`.
`RepositorySourceCapabilities` | `withSearches(boolean searches)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsSearches()`.
`RepositorySourceCapabilities` | `withUpdates(boolean updates)` Create a new instance that is a copy of this instance but uses the supplied value for `supportsUpdates()`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_SUPPORT_SAME_NAME_SIBLINGS

    public static final boolean DEFAULT_SUPPORT_SAME_NAME_SIBLINGS

  The default support for same-name-siblings is true .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_UPDATES

    public static final boolean DEFAULT_SUPPORT_UPDATES

  The default support for updates is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_EVENTS

    public static final boolean DEFAULT_SUPPORT_EVENTS

  The default support for updates is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_CREATING_WORKSPACES

    public static final boolean DEFAULT_SUPPORT_CREATING_WORKSPACES

  The default support for creating workspaces is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_REFERENCES

    public static final boolean DEFAULT_SUPPORT_REFERENCES

  The default support for references is true .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_QUERIES

    public static final boolean DEFAULT_SUPPORT_QUERIES

  The default support for querying workspaces is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_SEARCHES

    public static final boolean DEFAULT_SUPPORT_SEARCHES

  The default support for searching workspaces is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_LOCKS

    public static final boolean DEFAULT_SUPPORT_LOCKS

  The default support for creating locks is false .

  See Also:
    Constant Field Values

### DEFAULT_SUPPORT_AUTOMATIC_GARBAGE_COLLECTION

    public static final boolean DEFAULT_SUPPORT_AUTOMATIC_GARBAGE_COLLECTION

  The default support for automatic garbage collection is true .

  See Also:
    Constant Field Values

Constructor Detail

### RepositorySourceCapabilities

    public RepositorySourceCapabilities()

  Create a capabilities object using the defaults, .

### RepositorySourceCapabilities

    public RepositorySourceCapabilities(RepositorySourceCapabilities capabilities)

### RepositorySourceCapabilities

    public RepositorySourceCapabilities(boolean supportsSameNameSiblings,
                                        boolean supportsUpdates)

### RepositorySourceCapabilities

    public RepositorySourceCapabilities(boolean supportsSameNameSiblings,
                                        boolean supportsUpdates,
                                        boolean supportsEvents,
                                        boolean supportsCreatingWorkspaces,
                                        boolean supportsReferences)

### RepositorySourceCapabilities

    public RepositorySourceCapabilities(boolean supportsSameNameSiblings,
                                        boolean supportsUpdates,
                                        boolean supportsEvents,
                                        boolean supportsCreatingWorkspaces,
                                        boolean supportsReferences,
                                        boolean supportsLocks,
                                        boolean supportsQueries,
                                        boolean supportsSearches,
                                        boolean supportsAutomaticGarbageCollection)

Method Detail

### supportsSameNameSiblings

    public boolean supportsSameNameSiblings()

  Return whether the source supports same name siblings. If not, then no two siblings may share the same name.

  Returns:
    true if same name siblings are supported, or false otherwise

### supportsUpdates

    public boolean supportsUpdates()

  Return whether the source supports updates. This may be true, even though a particular connection made on behalf of a user may not have any update privileges. In other words, returning `false` implies that no connections would allow updates to the content.

  Returns:
    true if updates are supported, or false if the source only supports reads.

### supportsReferences

    public boolean supportsReferences()

  Return whether the source supports references by identifiers.

  Returns:
    true if references are supported, or false otherwise

### supportsEvents

    public boolean supportsEvents()

  Return whether the source supports publishing change events.

  Returns:
    true if events are supported, or false if the source is not capable of generating events

### supportsCreatingWorkspaces

    public boolean supportsCreatingWorkspaces()

  Return whether the source supports creating workspaces through the connector.

  Returns:
    true if creating workspaces is supported, or false if the source is not capable of creating workspaces

### supportsLocks

    public boolean supportsLocks()

  Return whether the source supports creating locks.

  Returns:
    true if locks are supported, or false if the source is not capable of creating locks

### supportsQueries

    public boolean supportsQueries()

  Return whether the source supports queries.

  Returns:
    true if queries are supported, or false if the source is not capable of querying content

### supportsSearches

    public boolean supportsSearches()

  Return whether the source supports full-text searches.

  Returns:
    true if searches are supported, or false if the source is not capable of searching content

### supportsAutomaticGarbageCollection

    public boolean supportsAutomaticGarbageCollection()

  Return whether the source supports automatic garbage collection. If not, then the source expects explicit `CollectGarbageRequest` calls.

  Returns:
    true if automatic garbage collection is supported, or false if the source is not capable of automatically collecting all of its garbage and requires periodic, manual collection

### withSameNameSiblings

    public RepositorySourceCapabilities withSameNameSiblings(boolean sameNameSiblings)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsSameNameSiblings()`.

  Parameters:
    `sameNameSiblings` - the new value
  Returns:
    the new instance

### withUpdates

    public RepositorySourceCapabilities withUpdates(boolean updates)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsUpdates()`.

  Parameters:
    `updates` - the new value
  Returns:
    the new instance

### withEvents

    public RepositorySourceCapabilities withEvents(boolean events)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsEvents()`.

  Parameters:
    `events` - the new value
  Returns:
    the new instance

### withCreatingWorkspaces

    public RepositorySourceCapabilities withCreatingWorkspaces(boolean creatingWorkspaces)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsCreatingWorkspaces()` .

  Parameters:
    `creatingWorkspaces` - the new value
  Returns:
    the new instance

### withReferences

    public RepositorySourceCapabilities withReferences(boolean references)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsReferences()`.

  Parameters:
    `references` - the new value
  Returns:
    the new instance

### withLocks

    public RepositorySourceCapabilities withLocks(boolean locks)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsLocks()`.

  Parameters:
    `locks` - the new value
  Returns:
    the new instance

### withQueries

    public RepositorySourceCapabilities withQueries(boolean queries)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsQueries()`.

  Parameters:
    `queries` - the new value
  Returns:
    the new instance

### withSearches

    public RepositorySourceCapabilities withSearches(boolean searches)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsSearches()`.

  Parameters:
    `searches` - the new value
  Returns:
    the new instance

### withAutomaticGarbageCollection

    public RepositorySourceCapabilities withAutomaticGarbageCollection(boolean autoGarbageCollection)

  Create a new instance that is a copy of this instance but uses the supplied value for `supportsAutomaticGarbageCollection()`.

  Parameters:
    `autoGarbageCollection` - the new value
  Returns:
    the new instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008-2011 JBoss, a division of Red Hat. All Rights Reserved.